;{ missing in PB
Structure socket 
  af.l
  type.l
  protocol.l
EndStructure

#_SS_MAXSIZE = 128
#_SS_ALIGNSIZE = SizeOf(quad)
#_SS_PAD1SIZE = #_SS_ALIGNSIZE - SizeOf(word)
#_SS_PAD2SIZE = (#_SS_MAXSIZE - (SizeOf(word) + #_SS_PAD1SIZE + #_SS_ALIGNSIZE))

Structure sockaddr_storage
  ss_family.w
  __ss_pad1.b[#_SS_PAD1SIZE]; 
  __ss_align.q; 
  __ss_pad2.b[#_SS_PAD2SIZE];
EndStructure

#INT_MAX = 2147483647
;}

#PCAP_VERSION_MAJOR = 2
#PCAP_VERSION_MINOR = 4
#PCAP_ERRBUF_SIZE = 256
Structure pcap_file_header
  magic.l
  version_major.w
  version_minor.w
  thiszone.l
  sigfigs.l
  snaplen.l
  linktype.l
EndStructure

Enumeration   ; pcap_direction_t
  #PCAP_D_INOUT = 0
  #PCAP_D_IN
  #PCAP_D_OUT
EndEnumeration

Structure pcap_pkthdr
  ts.timeval
  caplen.l
  len.l
EndStructure

Structure pcap_stat
  ps_recv.l
  ps_drop.l
  ps_ifdrop.l
  ps_capt.l
  ps_sent.l
  ps_netdrop.l
EndStructure

Structure pcap_stat_ex
  rx_packets.l
  tx_packets.l
  rx_bytes.l
  tx_bytes.l
  rx_errors.l
  tx_errors.l
  rx_dropped.l
  tx_dropped.l
  multicast.l
  collisions.l
  rx_length_errors.l
  rx_over_errors.l
  rx_crc_errors.l
  rx_frame_errors.l
  rx_fifo_errors.l
  rx_missed_errors.l
  tx_aborted_errors.l
  tx_carrier_errors.l
  tx_fifo_errors.l
  tx_heartbeat_errors.l
  tx_window_errors.l
EndStructure

Structure pcap_if
 *next.pcap_if
 name.s
 description.s
 *addresses.pcap_addr
  flags.l
EndStructure

Structure pcap_if_t Extends pcap_if
EndStructure

#PCAP_IF_LOOPBACK = $00000001
Structure pcap_addr
 *next.pcap_addr
 *addr.sockaddr
 *netmask.sockaddr
 *broadaddr.sockaddr
 *dstaddr.sockaddr
EndStructure

Structure pcap_addr_t Extends pcap_addr
EndStructure

#MODE_CAPT = 0
#MODE_STAT = 1
#MODE_MON = 2

XIncludeFile "bittypes.pb"
XIncludeFile "bucket_lookup.pb"
XIncludeFile "count_packets.pb"
XIncludeFile "Devioctl.pb"
XIncludeFile "ip6_misc.pb"
XIncludeFile "memory_t.pb"
XIncludeFile "normal_lookup.pb"
XIncludeFile "Ntddndis.pb"
XIncludeFile "Ntddpack.pb"
XIncludeFile "Packet32.pb"
XIncludeFile "pcap-bpf.pb"
XIncludeFile "pcap-stdinc.pb"
XIncludeFile "pthread.pb"
XIncludeFile "remote-ext.pb"
XIncludeFile "sched.pb"
XIncludeFile "tcp_session.pb"
XIncludeFile "time_calls.pb"
XIncludeFile "tme.pb"
XIncludeFile "Win32-Extensions.pb"

XIncludeFile "pcap-int.pb"

Prototype pcap_handler(user.s, *pkt_header.pcap_pkthdr, *pkt_data)

ImportC "wpcap.lib"
  pcap_open_live.l(device.s, snaplen.l, promisc.l, to_ms.l, *errbuf.s)
  pcap_open_dead.l(linktype.l, snaplen.l)
  pcap_open_offline.l(fname.s, *errbuf.s)	
  pcap_dump_open.l(*p.pcap_t, fname.s)	
  pcap_setnonblock.l(*p.pcap_t, nonblock.l, *errbuf.s)
  pcap_getnonblock.l(*p.pcap_t, *errbuf.s)
  pcap_findalldevs.l(*palldevsp, *errbuf.s)	
  pcap_freealldevs(*alldevsp.pcap_if_t)	
  pcap_lookupdev.l(errbuf.s)
  pcap_lookupnet.l(device.s, *netp.l, *maskp.l, *errbuf.s)
  pcap_dispatch.l(*p.pcap_t, cnt.l, callback.pcap_handler, *user)
  pcap_loop.l(*p.pcap_t, cnt.l, callback.pcap_handler, *user)
  pcap_next.l(*p.pcap_t, *h.pcap_pkthdr)
  pcap_next_ex.l(*p.pcap_t, *ppkt_header, *pkt_data)
  pcap_breakloop(*p.pcap_t)	
  pcap_sendpacket.l(*p.pcap_t, *buf, size.l)
  pcap_dump(user.s, *h.pcap_pkthdr, sp.s)
  pcap_dump_ftell.l(*p)
  pcap_compile.l(*p.pcap_t, *fp.bpf_program, str.s, optimize.l, netmask.l)
  pcap_compile_nopcap.l(snaplen_arg.l, linktype_arg.l, *program.bpf_program, *buf, optimize.l, mask.l)
 	pcap_setfilter.l(*p.pcap_t, *fp.bpf_program)
 	pcap_freecode(*fp.bpf_program)
 	pcap_datalink.l(*p.pcap_t)
 	pcap_list_datalinks.l(*p.pcap_t, *dlt_buf)
 	pcap_set_datalink.l(*p.pcap_t, dlt.l)
 	pcap_datalink_name_to_val.l(name.s)
 	pcap_datalink_val_to_name.l(dlt.l)
 	pcap_datalink_val_to_description.l(dlt.l)	
 	pcap_snapshot.l(*p.pcap_t)	
 	pcap_is_swapped.l(*p.pcap_t)	
 	pcap_major_version.l(*p.pcap_t)	
 	pcap_minor_version.l(*p.pcap_t)	
 	pcap_file.l(*p.pcap_t)	
 	pcap_stats.l(*p.pcap_t, *ps.pcap_stat)
 	pcap_perror(*p.pcap_t, prefix.s)
 	pcap_geterr.l(*p.pcap_t)
 	pcap_strerror.l(error.l)
 	pcap_lib_version()
 	pcap_close(*p.pcap_t)	
 	pcap_dump_file.l(*p)
 	pcap_dump_flush.l(*p)
 	pcap_dump_close(*p)
 	
  pcap_offline_filter.l(*prog.bpf_program, *header.pcap_pkthdr, *pkt_data)	
 	pcap_live_dump.l(*p.pcap_t, filename.s, maxsize.l, maxpacks.l)
 	pcap_live_dump_ended.l(*p.pcap_t, sync.l)	
 	pcap_stats_ex.l(*p.pcap_t, *pcap_stat_size.l)	
 	pcap_setbuff.l(*p.pcap_t, ldim.l)	
 	pcap_setmode.l(*p.pcap_t, mode.l)
 	pcap_setmintocopy.l(*p.pcap_t, size.l)
 	pcap_getevent.l(*p.pcap_t)	
 	pcap_sendqueue_alloc.l(memsize.l)
 	pcap_sendqueue_destroy(*queue.pcap_send_queue)
 	pcap_sendqueue_queue.l(*queue.pcap_send_queue, *pkt_header.pcap_pkthdr, *pkt_data)
 	pcap_sendqueue_transmit.l(*p.pcap_t, *queue.pcap_send_queue, sync.l)	
 	pcap_findalldevs_ex.l(source.s, *auth.pcap_rmtauth, *palldevs, *errbuf.s)
 	pcap_createsrcstr.l(source.s, type.l, host.s, port.s, name.s, *errbuf.s)
 	pcap_parsesrcstr.l(source.s, *type.l, host.s, port.s, name.s, *errbuf.s)
 	pcap_open.l(source.s, snaplen.l, flags.l, read_timeout.l, *auth.pcap_rmtauth, *errbuf.s)
 	pcap_setsampling.l(*p.pcap_t)
 	pcap_remoteact_accept.l(address.s, port.s, hostlist.s, connectinghost.s, *auth.pcap_rmtauth, *errbuf.s)
 	pcap_remoteact_close.l(host.s, *errbuf.s)
 	pcap_remoteact_cleanup()
 	pcap_remoteact_list.l(hostlist.s, sep.c, size.l, *errbuf.s)
EndImport
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 126
; FirstLine = 70
; Folding = -