; /*
;  * Copyright (c) 1999 - 2003
;  * NetGroup, Politecnico di Torino (Italy)
;  * All rights reserved.
;  * 
;  * Redistribution And use in source And binary forms, With Or without 
;  * modification, are permitted provided that the following conditions 
;  * are met:
;  * 
;  * 1. Redistributions of source code must retain the above copyright 
;  * notice, this list of conditions And the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright 
;  * notice, this list of conditions And the following disclaimer in the 
;  * documentation And/Or other materials provided With the distribution. 
;  * 3. Neither the name of the Politecnico di Torino nor the names of its 
;  * contributors may be used To endorse Or promote products derived from 
;  * this software without specific prior written permission. 
;  * 
;  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS And CONTRIBUTORS 
;  * "AS IS" And ANY EXPRESS Or IMPLIED WARRANTIES, INCLUDING, BUT Not 
;  * LIMITED To, THE IMPLIED WARRANTIES OF MERCHANTABILITY And FITNESS For 
;  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
;  * OWNER Or CONTRIBUTORS BE LIABLE For ANY DIRECT, INDIRECT, INCIDENTAL, 
;  * SPECIAL, EXEMPLARY, Or CONSEQUENTIAL DAMAGES (INCLUDING, BUT Not 
;  * LIMITED To, PROCUREMENT OF SUBSTITUTE GOODS Or SERVICES; LOSS OF USE, 
;  * Data, Or PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
;  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, Or TORT 
;  * (INCLUDING NEGLIGENCE Or OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
;  * OF THIS SOFTWARE, EVEN If ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;  * 
;  */

; PureBasic-Code by Deem2031


OpenConsole()
#AF_INET6 = 23

IncludePath "Include"
XIncludeFile "pcap.pb"

; #ifndef WIN32
;     #include <sys/socket.h>
;     #include <netinet/in.h>
; #else
;     #include <winsock.h>
; #endif


Declare ifprint(*d.pcap_if_t)
; Declare.s iptos(in.l)
; Declare.s ip6tos(*sockaddr.sockaddr, *address.s, addrlen.l)


Define *alldevs.pcap_if_t, *d.pcap_if_t, errbuf.s{#PCAP_ERRBUF_SIZE+1}, source.s

PrintN("Enter the device you want to list:")
PrintN("rpcap://              ==> lists interfaces in the local machine")
PrintN("rpcap://hostname:port ==> lists interfaces in a remote machine")
PrintN("                          (rpcapd daemon must be up and running")
PrintN("                           and it must accept 'null' authentication)")
PrintN("file://foldername     ==> lists all pcap files in the give folder")
PrintN("")
PrintN("Enter your choice: ");

source = Input()

;  /* Retrieve the interfaces list */
If pcap_findalldevs_ex(source, #Null, @*alldevs, @errbuf) = -1
  Print("Error in pcap_findalldevs: "+errbuf)
  Input()
  End
EndIf

;  /* Scan the list printing every entry */
*d = *alldevs
While *d
  ifprint(*d);
  *d = *d\next
Wend

pcap_freealldevs(*alldevs);

Input()

End #True



;/* Print all the available information on the given Interface */
Procedure ifprint(*d.pcap_if_t)
  Protected *a.pcap_addr_t, ip6str.s{128}, *tmp_sockaddr_in.sockaddr_in
  
  ;/* Name */
  PrintN(*d\name)

  ;/* Description */
  If *d\description
    PrintN(#TAB$+"Description: "+*d\description)
  EndIf

  ;/* Loopback Address*/
  If *d\flags & #PCAP_IF_LOOPBACK
    PrintN(#TAB$+"Loopback: yes")
  Else
    PrintN(#TAB$+"Loopback: no");
  EndIf

  ;/* IP addresses */
  *a = *d\addresses
  While *a
    PrintN(#TAB$+"Address Family: "+Str(*a\addr\sa_family))
  
    Select *a\addr\sa_family
      Case #AF_INET:
        PrintN(#TAB$+"Address Family Name: AF_INET")
        If *a\addr
          *tmp_sockaddr_in = *a\addr
          PrintN(#TAB$+"Address: "+IPString(*tmp_sockaddr_in\sin_addr))
        EndIf
        If *a\netmask
          *tmp_sockaddr_in = *a\netmask
          PrintN(#TAB$+"Netmask: "+IPString(*tmp_sockaddr_in\sin_addr))
        EndIf
        If *a\broadaddr
          *tmp_sockaddr_in = *a\broadaddr
          PrintN(#TAB$+"Broadcast Address: "+IPString(*tmp_sockaddr_in\sin_addr))
        EndIf
        If *a\dstaddr
          *tmp_sockaddr_in = *a\dstaddr
          PrintN(#TAB$+"Destination Address: "+IPString(*tmp_sockaddr_in\sin_addr))
        EndIf

      Case #AF_INET6
        PrintN(#TAB$+"Address Family Name: AF_INET6")
;         If *a\addr
;           PrintN(#TAB$+"Address: "+ip6tos(*a\addr, @ip6str, 128));
;         EndIf

      Default
        PrintN(#TAB$+"Address Family Name: Unknown")
    EndSelect
    *a = *a\next
  Wend
  PrintN("");
EndProcedure



;/* From tcptraceroute, convert a numeric IP address To a string */
; #IPTOSBUFFERS = 12
; Procedure.s iptos(in.l)
;     Static Dim output.c(#IPTOSBUFFERS,3*4+3+1)
;     Static which.w
;     Protected Dim *p.b(3)
; 
;     *p = in
;     If which + 1 = #IPTOSBUFFERS
;       which = 0
;     Else
;       which + 1
;     EndIf
;     PrintN(Chr(output(which,0))+Str(*p(0))+ Str(*p(1))+ Str(*p(2))+ Str(*p(3)))
;     ProcedureReturn Chr(output(which,0))
; EndProcedure

; Procedure.s ip6tos(*sockaddr.sockaddr, *address.s, addrlen.l)
;     Protected sockaddrlen.l
; 
;     sockaddrlen = 6
;     
;     If(getnameinfo(sockaddr, 
;         sockaddrlen, 
;         address, 
;         addrlen, 
;         NULL, 
;         0, 
;         NI_NUMERICHOST) != 0) address = NULL;
; 
;     Return address;
; EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 81
; FirstLine = 79
; Folding = -