OpenConsole()
#AF_INET6 = 23

IncludePath "Include"
XIncludeFile "pcap.pb"

;/* Prototype of the packet handler */
Declare packet_handler(*param.b, *header.pcap_pkthdr, *pkt_data.b)

Define *alldevs.pcap_if_t, *d.pcap_if_t, inum.l, i.l=0, *adhandle.pcap_t, errbuf.s{#PCAP_ERRBUF_SIZE}
    
;/* Retrieve the device list on the local machine */
If pcap_findalldevs_ex(#PCAP_SRC_IF_STRING, #Null, @*alldevs, @errbuf) = -1
  PrintN("Error in pcap_findalldevs: "+ errbuf)
  Input()
  End
EndIf

;/* Print the list */
*d = *alldevs
While *d
  
  i+1
  PrintN(Str(i)+": "+*d\name)
  
  If *d\description
    PrintN(*d\description);
  Else
    PrintN(" (No description available)");
  EndIf
  
  *d = *d\next
Wend  

If i = 0
  PrintN("No interfaces found! Make sure WinPcap is installed.")
  Input()
  End -1;
EndIf
    
Print("Enter the interface number (1-"+Str(i)+"): "): inum = Val(Input())
    
If (inum < 1) Or (inum > i)
  PrintN("Interface number out of range.")
  ;/* Free the device list */
  pcap_freealldevs(*alldevs)
  Input()
  End -1
EndIf
    
;/* Jump To the selected adapter */
*d = *alldevs
i = 0
While *d
  i+1
  If i = inum
    Break
  EndIf
  *d = *d\next
Wend
    
;/* Open the device */
adhandle = pcap_open(*d\name, 65536, #PCAP_OPENFLAG_PROMISCUOUS, 1000, #Null, @errbuf)

If adhandle = #Null
  PrintN("Unable to open the adapter. "+*d\name+" is not supported by WinPcap")
  ;/* Free the device list */
  pcap_freealldevs(*alldevs);
  Input()
  End -1;
EndIf
    
PrintN("listening on "+*d\description+"...")
    
;/* At this point, we don't need any more the device list. Free it */
pcap_freealldevs(*alldevs);
    
;/* start the capture */
pcap_loop(adhandle, 0, @packet_handler(), #Null);

Input()
End 0


;/* Callback function invoked by libpcap for every incoming packet */
ProcedureC packet_handler(*param.b, *header.pcap_pkthdr, *pkt_data.b)
  Protected ltime, timestr.s{16}
    
  ;/* convert the timestamp to readable format */
  If *header\ts
    timestr = FormatDate("%hh:%ii:%ss", *header\ts\tv_sec)
  
    PrintN(timestr+","+Str(*header\ts\tv_usec)+#TAB$+"len:"+Str(*header\len))
  EndIf
EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 78
; FirstLine = 25
; Folding = -